Attribute VB_Name = "Module1"
Option Explicit

Public Word As String
Dim CorrectCaseWord As String
Public CurrTxtBox As Control

' Declare Type for API call:
Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128   '  Maintenance string for PSS usage
End Type

' API declarations:
Private Declare Function GetVersionEx Lib "kernel32" _
   Alias "GetVersionExA" _
   (lpVersionInformation As OSVERSIONINFO) As Long

Private Declare Sub keybd_event Lib "user32" _
   (ByVal bVk As Byte, _
    ByVal bScan As Byte, _
    ByVal dwFlags As Long, ByVal dwExtraInfo As Long)

Private Declare Function GetKeyboardState Lib "user32" _
   (pbKeyState As Byte) As Long

Private Declare Function SetKeyboardState Lib "user32" _
   (lppbKeyState As Byte) As Long

'Constant declarations:
Const VK_CAPITAL = &H14
Const KEYEVENTF_EXTENDEDKEY = &H1
Const KEYEVENTF_KEYUP = &H2
Const VER_PLATFORM_WIN32_NT = 2
Const VER_PLATFORM_WIN32_WINDOWS = 1

Public Sub CapsOff()
'This procedure turns the CapsLock key off
Dim o As OSVERSIONINFO
  Dim NumLockState As Boolean
  Dim ScrollLockState As Boolean
  Dim CapsLockState As Boolean

  o.dwOSVersionInfoSize = Len(o)
  GetVersionEx o
  Dim keys(0 To 255) As Byte
  GetKeyboardState keys(0)

' CapsLock handling:
CapsLockState = keys(VK_CAPITAL)
    If CapsLockState = True Then    'Turn capslock off
      If o.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS Then  '=== Win95/98
        keys(VK_CAPITAL) = 0
        SetKeyboardState keys(0)
      ElseIf o.dwPlatformId = VER_PLATFORM_WIN32_NT Then   '=== WinNT
      'Simulate Key Press
        keybd_event VK_CAPITAL, &H45, KEYEVENTF_EXTENDEDKEY Or 0, 0
      'Simulate Key Release
        keybd_event VK_CAPITAL, &H45, KEYEVENTF_EXTENDEDKEY _
           Or KEYEVENTF_KEYUP, 0
      End If
    End If
End Sub
