VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "CapsLock handler"
   ClientHeight    =   2655
   ClientLeft      =   60
   ClientTop       =   375
   ClientWidth     =   6105
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2655
   ScaleWidth      =   6105
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   300
      Left            =   270
      TabIndex        =   0
      Top             =   1515
      Width           =   5565
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Exit"
      Height          =   435
      Left            =   4710
      TabIndex        =   1
      Top             =   2070
      Width           =   1170
   End
   Begin VB.Label Label1 
      Caption         =   $"CapsLock.frx":0000
      Height          =   840
      Left            =   585
      TabIndex        =   2
      Top             =   390
      Width           =   4965
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Word As String
Dim bNewSentence As Boolean
Dim lPos As Long

Private Sub Command1_Click()
End
End Sub

Private Sub Text1_KeyPress(KeyAscii As Integer)
Static i As Integer
Static InputString As String
Dim x As Long
    
    If Text1 = "" Then
        i = 0
        Exit Sub
    End If
    
    InputString = Text1     'Place contents of text box in variable
    
    'Always look for last space
    x = InStrRev(Text1.Text, " ")
    Word = Trim(Mid(InputString, x + 1))
    
    If KeyAscii = 32 Then   'Space bar pressed
        InputString = ""    'Clear variable
        i = i + Len(Word)
        Call Analyse
    End If
End Sub

Private Sub Analyse()
Dim FirstLetter As String
Dim LastLetter As String
Dim SeekString As String
Dim TextStart
Dim CorrectCaseWord As String

If Word = "" Then Exit Sub

'This procedure checks the word just typed to see is there
'is a Caps Lock problem. If not just reset variables.
FirstLetter = Left$(Word, 1)
LastLetter = Right$(Word, 1)

'If 1st letter is lower case and last letter is upper case
If Asc(FirstLetter) >= 97 And Asc(LastLetter) <= 90 Then
    'Correct capitalization if necessary
    If Len(Word) = Len(Text1) Then
        'Correct - convert to proper case
        CorrectCaseWord = UCase$(Left$(Word, 1)) & LCase$(Mid$(Word, 2))
    ElseIf bNewSentence = True Then
        'Correct - convert to proper case
        CorrectCaseWord = UCase$(Left$(Word, 1)) & LCase$(Mid$(Word, 2))
    Else
        'Correct - convert to lower case
        CorrectCaseWord = LCase$(Word)
    End If
    
    bNewSentence = False

    SeekString = Word
    'Search for text with incorrect capitalisation
    TextStart = InStr(Text1.Text, SeekString)
    Text1.SelStart = TextStart - 1
    Text1.SelLength = Len(Word)
    'Insert corrected case word
    Text1.SelText = CorrectCaseWord
    'Turn CapsLock off
    Call CapsOff
End If

If Right(Word, 1) = "." Or Right(Word, 1) = ":" Then
    bNewSentence = True
End If

'Reset variables
    Word = ""
    CorrectCaseWord = ""
    TextStart = 0
End Sub

